/* AhX` */
#define	RTC_SR		0x3f	/* Xe[^XEWX^ */
#define	RTC_SC		0x30	/* qsbZNV擪ibj */
#define	RTC_CONTROL	0x10	/* Rg[EWX^ */

/* Xe[^XEWX^̃rbg` */
#define	RTCSR_OSCF	0x10	/* Uُ */
#define	RTCSR_ZERO	0x08	/* 0 */
#define	RTCSR_RWEL	0x04	/* WX^ECgECl[uEb` */
#define	RTCSR_WEL	0x02	/* CgECl[uEb` */
#define	RTCSR_RTCF	0x01	/* dfԂ̕A */

/* h2bC^[tF[X֐iVXeɊ̂̂Ƃj */
long	WriteRTC(long, char *, long);	/* Cg֐CݐԂ */
void	ReadRTC(long, char *, long);	/* [h֐ */

/* ftHg̎ƃRg[WX^̓e */
char	default_time[] = {0, 0, 0, 1, 9, 7, 0, 0x20};/* 2007.9.1 0:00:00 */
char	default_control[] = {0, 0x10, 0, 0, 0x40};/* eout:4096gz */

/* Xe[^XEWX^̂vdkƂqvdkZbgCݓ\ɂ */
int	write_enable(void)
{
	char	w_buf[1],r_buf[1];/* ݃obt@Ɠǂݍ݃obt@ */
	int	n;
	
	ReadRTC(RTC_SR, r_buf, 1);/* Xe[^XEWX^ǂ */
	if((r_buf[0] & RTCSR_WEL) == 0){/* ܂vdkZbgĂȂꍇ */
		w_buf[0] = RTCSR_WEL;/* ރf[^ݒ */
		for(n = 0; n < 10; n++){
			WriteRTC(RTC_SR, w_buf, 1);/* AhXRTC_SRw_buf1oCg */
			ReadRTC(RTC_SR, r_buf, 1);/* AhXRTC_SRr_buf1oCgǂݍŊmF */
			if(r_buf[0] & RTCSR_ZERO)/* 0ɂȂׂrbg0łȂȂĎs */
				continue;
			if(r_buf[0] & RTCSR_WEL)
				break;/* vdkZbgĂȂ݂̏ */
		}
		if(n == 10)/* ^CAEgEG[ */
			return 1;
	}
	w_buf[0] = RTCSR_RWEL | RTCSR_WEL;/* ރf[^ݒ */
	for(n = 0; n < 3; n++){
		WriteRTC(RTC_SR, w_buf, 1);
		ReadRTC(RTC_SR, r_buf, 1);
		if(r_buf[0] & RTCSR_ZERO)
			continue;
		if((r_buf[0] & (RTCSR_RWEL | RTCSR_WEL)) == (RTCSR_RWEL | RTCSR_WEL))
			break;/* vdkƂqvdkZbgĂȂ珑ݏI */
	}
	if(n == 3)/* ^CAEgEG[ */
		return 2;
	return 0;/* I */
}

/* hrk12026̏DIF0CG[F̐ */
int	rtc_init(void)
{
	char	buf[1];/* I2CC^[tF[Xǂݎf[^̃obt@ */
	int	m,n;

	xmt_pause(100);/* 100msec̃EFCgi^C}g̊֐j */
	for(m = 0, n = 0; n < 10; n++){/* h2bC^[tF[X̊mF */
		xmt_pause(20);/* 20msec̃EFCg */
		ReadRTC(RTC_SR, buf,1);/* Xe[^XEWX^ǂ */
		if((buf[0] & RTCSR_ZERO) == 0)/* 0łׂrbg0@*/
			m++;/* ǂݍ݉񐔂CNg */
		else/* ُf[^ɂāCǂݍ݉񐔂Zbg */
			m = 0;
	}
	if(m == 0)/* ǂݍ݂Ȃ */
		return 1;/* ^CAEgCh2bC^[tF[Ẍُ */
	if(buf[0] & RTCSR_RTCF){/* dfԂ̕Ai߂Ă̒ʓdj */
		if(write_enable() != 0)/* ݉\ɂłȂ */
			return 2;/* G[E^[ */
		/* ftHg̎ށislrq`l̈Ȃ̂ŁCxt@CȂj */
		WriteRTC(RTC_SC, default_time, 8);
		if(write_enable() != 0)/* ݉\ɂłȂ */
			return 3;/* G[E^[ */
		/* Rg[EWX^ɃftHglZbgiddoqnl̈Ȃ̂ŁCxt@Ctj */
		if(WriteRTC(RTC_CONTROL, default_control, 5) != 5)/* ُ݈ */
			return 4;/* G[E^[ */
		if(write_enable() != 0)/* ݉\ɂłȂ */
			return 5;/* G[E^[ */
		WriteRTC(RTC_SC, default_time, 1);/* vJn̂߂1oCg̏ */
		ReadRTC(RTC_SR, buf, 1);/* Xe[^XEWX^ǂ */
		if(buf[0] & RTCSR_RTCF)/* RTCFZbg͂܂ */
			return 6;/* G[E^[ */
	}
	if(buf[0] & RTCSR_OSCF)/* Uُ */
		return 7;/* G[E^[ */
	return 0;/* I */
}
